/*-----------------------------------------------------------------------------
 *      GCC sections usage demo (AVR/avr-gcc)
 *-----------------------------------------------------------------------------
 *  Copyright (c) 2011 Oleksandr Redchuk aka ReAl http://real.kiev.ua
 *  Public domain, AS IS.
 *-----------------------------------------------------------------------------
 */

#include "sections_demo.h"

static const prog_char name2a[] = "Module 2-A";
static const prog_char name2b[] = "Module 2-B";
static const prog_char name2c[] = "Module 2-C";

static void func_c()
{
    uart_putstr_P(PSTR("Module 2 function C called\n"));
}

INIT(8)
{
    uart_putstr_P(PSTR("Module 2-C initialised\n"));
}

static module_decriptor_t module2c SECTION(module_list.025) = {
    name2c, func_c, 'x'
};


static void func_b()
{
    uart_putstr_P(PSTR("Module 2 function B called\n"));
}

static void func_a()
{
    uart_putstr_P(PSTR("Module 2 function A called\n"));
}

static module_decriptor_t module2ab[] SECTION(module_list.020) = {
	{ name2a, func_a, 'w' },
	{ name2b, func_b, 'W' }
};

INIT(8)
{
    uart_putstr_P(PSTR("Module 2-B initialised\n"));
}

INIT(8)
{
    uart_putstr_P(PSTR("Module 2-A initialised\n"));
}
